#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

int main() {
    char *s;
    struct stat statbuf;

    /*
     * aehnlich zu stat() und lstat() ermittelt
     * fstat() Informationen ueber eine Datei, die
     * bei fstat() mit dem Filedeskriptor (statt einem
     * Dateinamen) bezeichnet wird - es handelt sich
     * also hierbei immer um eine bereits offene Dateiverbindung,
     * in diesem Beispiel die Standardeingabe (da Filedesk. 0)
     */
    if (fstat(0, &statbuf) < 0)
	perror("fstat"), exit(1);

    /* analog ... */
    switch (statbuf.st_mode & S_IFMT) {
	case S_IFREG  : s = "normale Datei"; break;
	case S_IFDIR  : s = "Verzeichnis"; break;
	case S_IFCHR  : s = "zeichenorient. Geraet"; break;
	case S_IFBLK  : s = "blockorient. Geraet"; break;
	case S_IFLNK  : s = "symbolischer Link"; break;
	case S_IFIFO  : s = "FIFO"; break;
	case S_IFSOCK : s = "Socket"; break;
	default:	s = "_unbekannt_"; break;
    }
    printf("Datei-Typ: %s\n", s);

    return 0;
}
