#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

#define BUFLEN 128

/* liest eine Zeile von der I/O-Verbindung, die fd bezeichnet,
 * aber maximal buflen-1 viele Zeichen
 */
int readline(int fd, char *buf, int buflen) {
    int res, len;

    /* eine Zeile (aber max. BUFLEN-1 Zeichen) von stdin lesen */
    for (len = 0; len < buflen-1; len++) {
	/* ein Zeichen von stdin in den Puffer lesen */
	if ((res = read(fd, buf+len, 1)) < 0)
	    return -1;
	/* bei EOF oder '\n' ist Schluss mit dem Einlesen */
	if (res == 0 || buf[len] == '\n')
	    break;
    }
    
    /* String noch sauber mit einem Null-Byte terminieren */
    buf[len] = '\0';

    return len;
}

int main() {
    char buf[BUFLEN];

    if (readline(0, buf, BUFLEN) < 0)
	perror("readline"), exit(1);
        
    /* ... und auf stdout ausgeben */
    puts(buf);
    
    return 0;
}
