#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

int main(int argc, char **argv) {
    char *s;
    struct stat statbuf;

    if (argc != 2) {
	fprintf(stderr, "Usage: %s <file>\n", argv[0]);
	return 1;
    }

    /*
     * auf Basis des Dateinamens in argv[1] Infos zur
     * Datei beschaffen (=> statbuf)
     *
     * Unterschied zw. stat() und lstat():
     * bei symb. Links behandelt stat() den Link wie die
     * Datei, auf die er verweist, und lstat() wie den Link selbst
     */
    if (stat(argv[1], &statbuf) < 0)
	perror("stat"), exit(2);

    /* Bestimmung des Dateityps ... */
    switch (statbuf.st_mode & S_IFMT) {
	case S_IFREG  : s = "normale Datei"; break;
	case S_IFDIR  : s = "Verzeichnis"; break;
	case S_IFCHR  : s = "zeichenorient. Geraet"; break;
	case S_IFBLK  : s = "blockorient. Geraet"; break;
	case S_IFLNK  : s = "symbolischer Link"; break;
	case S_IFIFO  : s = "FIFO"; break;
	case S_IFSOCK : s = "Socket"; break;
	default:	s = "_unbekannt_"; break;
    }
    printf("Datei-Typ: %s\n", s);

    return 0;
}
